/* mangen ImagePacket \- NDDS methods for ImagePacket type
   banner = ==========
  
   This file is derived from code automatically generated by nddsgen.

   modification history
   ------------ -------
   19a,29aug95,gpc Mofified for version 1.9
   19a,20Aug95,gpc Auto-gen code for ImagePacketAllocate and ImagePacketFree
   RTI,30may94,sas cleanup.
   RTI,02apr94,gpc Auto-generated code template written.
 */

/*
static char copyright_rti[] = 
"(c) Copyright, Real-Time Innovations, Inc., 1994.  All rights reserved.";
*/

/*
DESCRIPTION:
This file implements the NDDS methods required to declare a ImagePacket 
type to NDDS. This file was automatically generated by the 'nddsgen'
code generator from a specification of the ImagePacket type given in
the XDR language. See the man pages on 'nddsgen' and 'NddsXDR'.

This file was generated with the following steps:

(1) A description of the type ImagePacket was written in a file
named ImagePacket.x (NOTE: the .x termination which is standard
for this files is required.). This description uses the XDR language,
which resembles "C"-like structure-type declarations. More information 
and examples on how to write these ".x" files can be found in the 
man page for 'nddsgen'.

(2) 'nddsgen' was run on the ImagePacket.x file. This created the
ImagePacket_stubs.c, ImagePacket_xdr.c, ImagePacket.h 
and ImagePacket_test.c files.

(3) The ImagePacket_stubs.c was copied into ImagePacket.c; 
this file contains the functions, ImagePacketSeralize(), 
ImagePacketDeserialize(), and ImagePacketPrint() that are 
required to register the ImagePacket type with NDDS. 

(4) The user may want to fill in the code for the ImagePacketPrint()
function if he/she wants NDDS to print the ImagePacket automatically
in certain situations. This isn't required.

(5) The file ImagePacket.c also contains the function 
ImagePacketInit(). This function will register the 
ImagePacket type with NDDS.

(6) The ImagePacket_test.c contains code to test the 
serialization/deserialization functions. It is advisable to 
compile and run this program to verify proper operation.

SEE ALSO:
nddsgen, NddsXDR, NDDS, NddsTypeRegister.
--------------------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ImagePacket.h"

/* ========================================================================
   ImagePacketSerialize \- NDDS serialization method for ImagePacket

   Required NDDS method to serialize an ImagePacket into NDDSXDRStream 
   buffer.
   The data will be deserialized by the ImagePacketDeserialize() function.

   The 'options' may be defined and used for customizing serialization
   for different situations. Often (as in this case) they are simply 
   ignored.
 */
boolean ImagePacketSerialize(NDDSXDRStream nddsds,
			      ImagePacket nddsImagePacket,
			      int options)
{
    return xdr_ImagePacketStruct(NddsXDRGetSerializingStream(nddsds),
			       nddsImagePacket);
}

/* ========================================================================
   ImagePacketDeserialize \- NDDS deserialization method for ImagePacket 
   
   Required NDDS method to deserialize the data from an NDDSXDRStream buffer.
   The data was serialized by the ImagePacketSerialize() function.

   If outArray==NULL (null pointer), this function will create a
   ImagePacket of the appropriate size to hold the data 
   (as required by NDDS).

   Returns the output array or NULL if an error ocurred
 */
ImagePacket ImagePacketDeserialize(ImagePacket nddsImagePacket,
				     NDDSXDRStream nddsds)
{
    int allocated = FALSE;

    if (nddsImagePacket == NULL) {
	allocated = TRUE;
	nddsImagePacket = calloc(1, sizeof(*nddsImagePacket));
    }

    if (!xdr_ImagePacketStruct(NddsXDRGetDeserializingStream(nddsds),
			     nddsImagePacket))  {
	if (allocated) {
	    free(nddsImagePacket);
	}
	return NULL;
    }
    
    return nddsImagePacket;
}

/* ========================================================================
   ImagePacketPrint \- NDDS Print method for ImagePacket objects

   Optional NDDS method to print the contents of an ImagePacket.

   Note that if this method *must* handle the case where the object
   is NULL.
 */
ImagePacket ImagePacketPrint(ImagePacket nddsImagePacket)
{
    /* Do not remove. ImagePacketPrint must handle a NULL 
       ImagePacket 
       */
    if (nddsImagePacket==NULL) {
	printf("ImagePacket: (null)\n");
	return NULL;
    }

    /* Replace by custom code if desired */
    if (!NddsPrint_ImagePacketStruct(nddsImagePacket, "ImagePacket", 0)) {
	printf("NddsPrint_ImagePacketStruct() failed on %p\n", nddsImagePacket);
	return NULL;
    }

    /* Do not remove the return value */
    return nddsImagePacket;
}

/* ========================================================================
   ImagePacketAllocate \- NDDS Allocate method for ImagePacket objects

   Optional NDDS method to allocate an NDDS object of type ImagePacket.

   If registered within ImagePacketNddsRegister(), this method will be 
   invoked as a result of pattern subscriptions. When the NDDS agent 
   subscribes to a production that matches the requested pattern, it
   needs to create a new object of the corresponding type to hold the 
   updates when they come. 
   It is for this purpose that ImagePacketAllocate() is used.

   This method is not always required bacause ImagePacketDeserialize()
   is usually able to allocate the object itself. There are however
   some cases (notably strings) for which the allocation provided
   by ImagePacketDeserialize() isn't sufficient. Registration
   of ImagePacketAllocate() allows to override the default allocation
   provided by ImagePacketDeserialize().

   If this method is to be used, it must passed to NddsTypeRegister()
   (in function ImagePacketNddsRegister()) instead of the default
   NULL method.

   This routine gets passed the type and name of the object instance and
   the parameter provided by the user passed in the 
   NddsConsumerAddSubscription() call.
 */
ImagePacket ImagePacketAllocate(const char *type, const char *name,
				  void *userParam)
{
    ImagePacket nddsImagePacket;

    nddsImagePacket = (ImagePacket)calloc(1, sizeof(*nddsImagePacket));
    {
	/* Add the custom allocation of entries in the structure here */
        nddsImagePacket->line_data.line_data_len = (int)userParam;
        nddsImagePacket->line_data.line_data_val =
            (unsigned char *)malloc(nddsImagePacket->line_data.line_data_len
                                    * sizeof (unsigned char));
    }

    return nddsImagePacket;
}

/* ========================================================================
   ImagePacketFree \- NDDS Free method for ImagePacket objects

   Optional NDDS method to Free an NDDS object of type ImagePacket.

   This method is not used in the current version of NDDS.
 */
boolean ImagePacketFree(ImagePacket inst,
			 const char *type, const char *name,
			 void *userParam)
{
    return TRUE;
}

/* ========================================================================
   ImagePacketNddsRegister \- Install ImagePacket type to NDDS
   
   This function will register an ImagePacket type with NDDS.   
   Registration must happen before any reference to the ImagePacket 
   type is given to NDDS.
 */
void ImagePacketNddsRegister(void)
{
   NddsTypeRegister("ImagePacket",
		    (SerializeMethodType)ImagePacketSerialize,
		    (DeserializeMethodType)ImagePacketDeserialize,
		    (PrintMethodType)ImagePacketPrint,
		    (AllocateMethodType)NULL,
		    (FreeMethodType)NULL);
}

