/* $Revision: 1.2 $ $Author: nomad $ $Date: 1997/05/05 01:36:45 $ */
#ifndef INCisParseArgs_h
#define INCisParseArgs_h

/****************************************************************************
 *
 * PROJECT: Nomad
 *
 * MODULE:  imageSender
 *
 * FILE:    isParseArgs.h
 *
 * DESCRIPTION: 
 *  Command line argument parsing for imageReceive
 *
 * EXPORTS:  
 *
 * NOTES:        
 *
 * REVISION HISTORY:
 * $Log: isParseArgs.h,v $
 * Revision 1.2  1997/05/05 01:36:45  nomad
 * About to test on NT for the first time.  -Kurt Schwehr
 *
 * Revision 1.1  1997/05/04 22:37:44  nomad
 * Initial version of command line argument processing header file.
 * Derived from imageReceive command line code.
 *   -Kurt Schwehr
 *
 *
 *
 * (c) Copyright 1996 NASA. All rights reserved.
 ***************************************************************************/

//#include "nomadNddsDomain.h"
struct ArgValues {

    NDDSDomain nddsDomain;
    NDDSMulticastInfoStorage multicastInfo; /* domain and TTL */

    int nddsVerb;	/* NDDS Verbosities.  -1 gives the default. */
    int nddsErrorVerb;
    int nddsDebugVerb;

    int debug_level;	/* imageReceive debug level */
};


#ifdef __cplusplus
extern "C" {
#endif

int ISParseArgs (struct ArgValues *argValues);


#ifdef __cplusplus
}  /* extern "C" */
#endif

#endif /* INCisParseArgs_h */
