/* mangen panoReceive \- NDDS methods for panoReceive type
   banner = ==========
  
   This file is derived from code automatically generated by nddsgen.

   modification history
   ------------ -------
   19a,29aug95,gpc Mofified for version 1.9
   19a,20Aug95,gpc Auto-gen code for panoReceiveAllocate and panoReceiveFree
   RTI,30may94,sas cleanup.
   RTI,02apr94,gpc Auto-generated code template written.
 */

static char copyright_rti[] = 
"(c) Copyright, Real-Time Innovations, Inc., 1994.  All rights reserved.";

/*
DESCRIPTION:
This file implements the NDDS methods required to declare a panoReceive 
type to NDDS. This file was automatically generated by the 'nddsgen'
code generator from a specification of the panoReceive type given in
the XDR language. See the man pages on 'nddsgen' and 'NddsXDR'.

This file was generated with the following steps:

(1) A description of the type panoReceive was written in a file
named panoReceive.x (NOTE: the .x termination which is standard
for this files is required.). This description uses the XDR language,
which resembles "C"-like structure-type declarations. More information 
and examples on how to write these ".x" files can be found in the 
man page for 'nddsgen'.

(2) 'nddsgen' was run on the panoReceive.x file. The command was:
    c:\rti\ndds.1.11d\bin\i86Win32\nddsgen panoReceive.x -t panoReceiveStruct -n panoReceive -ex

This created the panoReceive_stubs.c, panoReceive_xdr.c, panoReceive.h 
and panoReceive_test.c files.

(3) The panoReceive_stubs.c was copied into panoReceive.c; 
this file contains the functions, panoReceiveSeralize(), 
panoReceiveDeserialize(), and panoReceivePrint() that are 
required to register the panoReceive type with NDDS. 

(4) The user may want to fill in the code for the panoReceivePrint()
function if he/she wants NDDS to print the panoReceive automatically
in certain situations. This isn't required.

(5) The file panoReceive.c also contains the function 
panoReceiveInit(). This function will register the 
panoReceive type with NDDS.

(6) The panoReceive_test.c contains code to test the 
serialization/deserialization functions. It is advisable to 
compile and run this program to verify proper operation.

SEE ALSO:
nddsgen(1), NddsXDR(2), Ndds(2)
  panoReceiveNddsRegister(3)
--------------------------------------------------------------------------- */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "panoReceive.h"

/* ========================================================================
   panoReceiveSerialize \- NDDS serialization method for panoReceive

   Required NDDS method to serialize an panoReceive into NDDSXDRStream 
   buffer.
   The data will be deserialized by the panoReceiveDeserialize() function.

   The 'options' may be defined and used for customizing serialization
   for different situations. Often (as in this case) they are simply 
   ignored.
 */
boolean panoReceiveSerialize(NDDSXDRStream nddsds,
			      panoReceive nddspanoReceive,
			      int options)
{
    return xdr_panoReceiveStruct(NddsXDRGetSerializingStream(nddsds),
			       nddspanoReceive);
}

/* ========================================================================
   panoReceiveDeserialize \- NDDS deserialization method for panoReceive 
   
   Required NDDS method to deserialize the data from an NDDSXDRStream buffer.
   The data was serialized by the panoReceiveSerialize() function.

   If outArray==NULL (null pointer), this function will create a
   panoReceive of the appropriate size to hold the data 
   (as required by NDDS).

   Returns the output array or NULL if an error occurred
 */
panoReceive panoReceiveDeserialize(panoReceive nddspanoReceive,
				     NDDSXDRStream nddsds)
{
    int allocated = FALSE;

    if (nddspanoReceive == NULL) {
	allocated = TRUE;
	nddspanoReceive = calloc(1, sizeof(*nddspanoReceive));
    }

    if (!xdr_panoReceiveStruct(NddsXDRGetDeserializingStream(nddsds),
			     nddspanoReceive))  {
	if (allocated) {
	    free(nddspanoReceive);
	}
	return NULL;
    }
    
    return nddspanoReceive;
}

/* ========================================================================
   panoReceivePrint \- NDDS Print method for panoReceive objects

   Optional NDDS method to print the contents of an panoReceive.

   Note that if this method *must* handle the case where the object
   is NULL.
 */
panoReceive panoReceivePrint(panoReceive nddspanoReceive)
{
    /* Do not remove. panoReceivePrint must handle a NULL 
       panoReceive 
       */
    if (nddspanoReceive==NULL) {
	printf("panoReceive: (null)\n");
	return NULL;
    }

    /* Replace by custom code if desired */
    if (!NddsPrint_panoReceiveStruct(nddspanoReceive, "panoReceive", 0)) {
	printf("NddsPrint_panoReceiveStruct() failed on %p\n", nddspanoReceive);
	return NULL;
    }

    /* Do not remove the return value */
    return nddspanoReceive;
}

/* ========================================================================
   panoReceiveAllocate \- NDDS Allocate method for panoReceive objects

   Optional NDDS method to allocate an NDDS object of type panoReceive.

   If registered within panoReceiveNddsRegister(), this method will be 
   invoked as a result of pattern subscriptions. When the NDDS agent 
   subscribes to a production that matches the requested pattern, it
   needs to create a new object of the corresponding type to hold the 
   updates when they come. 
   It is for this purpose that panoReceiveAllocate() is used.

   This method is not always required because panoReceiveDeserialize()
   is usually able to allocate the object itself. There are however
   some cases (notably strings) for which the allocation provided
   by panoReceiveDeserialize() isn't sufficient. Registration
   of panoReceiveAllocate() allows to override the default allocation
   provided by panoReceiveDeserialize().

   If this method is to be used, it must passed to NddsTypeRegister()
   (in function panoReceiveNddsRegister()) instead of the default
   NULL method.

   This routine gets passed the type and name of the object instance and
   the parameter provided by the user passed in the 
   NddsConsumerAddSubscription() call.
 */
panoReceive panoReceiveAllocate(const char *type, const char *name,
				  void *userParam)
{
    panoReceive nddspanoReceive;

    nddspanoReceive = (panoReceive)calloc(1, sizeof(*nddspanoReceive));
    {
	/* Add the custom allocation of entries in the structure here */
    }

    return nddspanoReceive;
}

/* ========================================================================
   panoReceiveFree \- NDDS Free method for panoReceive objects

   Optional NDDS method to Free an NDDS object of type panoReceive.

   This method is not used in the current version of NDDS.
 */
boolean panoReceiveFree(panoReceive inst,
			 const char *type, const char *name,
			 void *userParam)
{
    return TRUE;
}

/* ========================================================================
   panoReceiveNddsRegister \- Install panoReceive type to NDDS
   
   This function will register an panoReceive type with NDDS.   
   Registration must happen before any reference to the panoReceive 
   type is given to NDDS.
 */
void panoReceiveNddsRegister(void)
{
   NddsTypeRegister("panoReceive",
		    (SerializeMethodType)panoReceiveSerialize,
		    (DeserializeMethodType)panoReceiveDeserialize,
		    (PrintMethodType)panoReceivePrint,
		    (AllocateMethodType)NULL,
		    (FreeMethodType)NULL);
}

